"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setupUrl = void 0;
const tslib_1 = require("tslib");
const interactive_1 = require("../../../global/options/interactive");
const url_constant_1 = require("./url.constant");
const prompt_1 = require("../../../core/prompt");
const validation_1 = require("../../../core/validation");
function setupUrl(config) {
    var _a;
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        let url = (_a = config === null || config === void 0 ? void 0 : config.collect) === null || _a === void 0 ? void 0 : _a.url;
        if ((0, interactive_1.get)()) {
            url = yield (0, prompt_1.promptParam)({
                message: url_constant_1.PROMPT_COLLECT_URL,
                initial: url || url_constant_1.DEFAULT_COLLECT_URL,
                skip: validation_1.VALIDATORS.required(url) === null
            });
        }
        const errors = (0, validation_1.applyValidations)(url, [
            validation_1.VALIDATORS.required
        ]);
        if ((0, validation_1.hasError)(errors)) {
            throw new Error(url_constant_1.ERROR_COLLECT_URL_REQUIRED);
        }
        return Object.assign(Object.assign({}, config), { collect: Object.assign(Object.assign({}, config === null || config === void 0 ? void 0 : config.collect), { url }) });
    });
}
exports.setupUrl = setupUrl;
//# sourceMappingURL=url.setup.js.map