"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserFlowRunnerExtension = void 0;
const tslib_1 = require("tslib");
const replay_1 = require("@puppeteer/replay");
const utils_1 = require("./utils");
class UserFlowRunnerExtension extends replay_1.PuppeteerRunnerExtension {
    constructor(browser, page, flow, opts) {
        super(browser, page, opts);
        this.flow = flow;
    }
    // eslint-disable-next-line
    // @ts-ignore
    runStep(step, flowRecording) {
        const _super = Object.create(null, {
            runStep: { get: () => super.runStep }
        });
        var _a;
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            if ((0, utils_1.isMeasureType)(step.type) && !((_a = this.flow) === null || _a === void 0 ? void 0 : _a.currentTimespan)) {
                const userFlowStep = step;
                const stepOptions = userFlowStep === null || userFlowStep === void 0 ? void 0 : userFlowStep.stepOptions;
                if (userFlowStep.type === 'navigate') {
                    return this.flow[userFlowStep.type](userFlowStep === null || userFlowStep === void 0 ? void 0 : userFlowStep.url, Object.assign({}, stepOptions));
                }
                return this.flow[userFlowStep.type](Object.assign({}, stepOptions));
            }
            else {
                return _super.runStep.call(this, step, flowRecording);
            }
        });
    }
}
exports.UserFlowRunnerExtension = UserFlowRunnerExtension;
//# sourceMappingURL=runner-extension.js.map