"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.openFlowReport = void 0;
const tslib_1 = require("tslib");
const dryRun_1 = require("../../../../commands/collect/options/dryRun");
const openReport_1 = require("../../options/openReport");
const interactive_1 = require("../../../../global/options/interactive");
const loggin_1 = require("../../../../core/loggin");
const openFileInBrowser = require("open");
function openFlowReport(fileNames) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        // open report if requested and not in executed in CI
        if (!(0, dryRun_1.get)() && (0, openReport_1.get)() && (0, interactive_1.get)()) {
            const htmlReport = fileNames.find(i => i.includes('.html'));
            if (htmlReport) {
                (0, loggin_1.logVerbose)('open HTML report in browser');
                yield openFileInBrowser(htmlReport, { wait: false });
                return Promise.resolve(void 0);
            }
            const mdReport = fileNames.find(i => i.includes('.md'));
            if (mdReport) {
                (0, loggin_1.logVerbose)('open Markdown report in browser');
                yield openFileInBrowser(mdReport, { wait: false });
                return Promise.resolve(void 0);
            }
            const jsonReport = fileNames.find(i => i.includes('.json'));
            if (jsonReport) {
                (0, loggin_1.logVerbose)('open JSON report in browser');
                // @TODO if JSON is given open the file in https://googlechrome.github.io/lighthouse/viewer/
                yield openFileInBrowser(jsonReport, { wait: false });
            }
        }
        return Promise.resolve(void 0);
    });
}
exports.openFlowReport = openFlowReport;
//# sourceMappingURL=open-report.js.map