"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VALIDATORS = exports.hasError = exports.applyValidations = void 0;
function applyValidations(value, validators) {
    return validators.reduce((errors, validator) => {
        return Object.assign(Object.assign({}, errors), (validator(value) || {}));
    }, {});
}
exports.applyValidations = applyValidations;
function hasError(errors) {
    return Object.entries(errors).length > 0;
}
exports.hasError = hasError;
const oneOf = (set) => (value) => {
    return (set.find(i => {
        return i === value;
    }) === undefined) ? {
        oneOf: { value }
    }
        : null;
};
exports.VALIDATORS = {
    required: (value) => value !== undefined && value !== '' ? null : { required: true },
    oneOf,
    allOf: (set) => (values) => {
        const _oneOf = oneOf(set);
        let errors = null;
        // @ts-ignore
        values.forEach((value) => {
            const e = _oneOf(value);
            if (e) {
                errors = {
                    allOf: { value },
                };
            }
        });
        return errors;
    }
};
//# sourceMappingURL=index.js.map